#!/bin/bash
#by Wiboon Warasittichai, last updated 29-11-62
#
if [ -z "$(id -nG|grep -w "root")" ]; then
  echo "need root access, try: sudo bash $0"
  exit
fi

#get current working directory
cwd="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

hname=/etc/hostname
echo Current hostname used in 2 files. 
echo ------------------------------------------------------
echo 1. ${hname}
cat ${hname}
echo ------------------------------------------------------
hlookup=/etc/hosts
echo
echo 2. ${hlookup}
cat ${hlookup}
echo ------------------------------------------------------

current=$(cat ${hname})
echo Your current hostname is: ${current}
echo
echo 'To change hostname, enter your new hostname: '
read valhname
if [ ! -z "${valhname}" ]; then
  sed "s/${current}/${valhname}/g" ${hname} > /tmp/file1.$$ 
  sed "s/${current}/${valhname}/g" ${hlookup} > /tmp/file2.$$
  echo
  echo Your new ${hname}
  echo ------------------------------------------------------
  cat /tmp/file1.$$
  echo
  echo Your new ${hlookup}
  echo ------------------------------------------------------
  cat /tmp/file2.$$
else
  echo
  echo Do nothing.
  echo
  exit
fi
while true;
do
  echo
  echo -n "Would you like to change hostname "
  read -p "(y/n) " AKEY
  case ${AKEY} in
    [Yy]*) ANS="YES" ; break ;;
    [Nn]*) ANS="NO" ; break ;;
    *) echo "Please answer y or n." ;;
  esac
done
if [ "${ANS}" = "YES" ]; then
  cp /tmp/file1.$$ ${hname}
  cp /tmp/file2.$$ ${hlookup}
  echo
  echo Hostname changed.
  echo You have to reboot system to take effect.
  echo
else
  echo
  echo Do nothing.
  echo
fi
rm -f /tmp/file1.$$
rm -f /tmp/file2.$$ 

