#!/bin/bash
#by Wiboon Warasittichai, last updated 28-11-62
#
if [ -z "$(id -nG|grep -w "root")" ]; then
  echo "need root access, try: sudo bash $0"
  exit
fi

#get current working directory
cwd="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

TEMPLATEFILE=$cwd/01-netcfg.yaml.template
NETCONFIGFILE=/etc/netplan/01-netcfg.yaml
NETNAMEFILE=${HOME}/netname
if [ ! -f ${NETNAMEFILE} ] || [ "$1" = "--reconfigure" ]; then
  ASKNAME="YES"
else
  while true; do
    echo
    echo Network interface name store in file ${NETNAMEFILE} is $(cat ${NETNAMEFILE})
    echo -n "Would you like to change network interface name "
    read -p "(y/n) " AKEY
    case ${AKEY} in
      [Yy]*) ASKNAME="YES" ; break ;;
      [Nn]*) ASKNAME="NO" ; break ;;
      *) echo "Please answer y or n." ;;
    esac
  done
fi

while true; 
do
if [ "${ASKNAME}" = "YES" ]; then
  echo 'Network interface name found: '
  ifconfig -a | grep 'flags=' | grep -v 'mtu 65536' | cut -d: -f1
  while true;
  do
    echo
    echo 'Enter network interface name (you selected): '
    read NETNAME
    if [ ! -z "${NETNAME}" ]; then
      if [ ! -z "$(ifconfig -a | grep 'flags=' | grep -v 'mtu 65536' | cut -d: -f1 | grep -w ${NETNAME})" ]; then
        echo
        echo "network interface name : ${NETNAME}"
        echo ${NETNAME} > ${NETNAMEFILE}
	echo
        echo ${NETCONFIGFILE}:
        sed "s/enp0s3/${NETNAME}/g" ${TEMPLATEFILE} | sudo tee ${NETCONFIGFILE}
	sudo netplan apply
        exit
      fi
    fi
  done
else
  NETNAME=$(cat ${NETNAMEFILE})
  if [ ! -z "$(ifconfig -a | grep 'flags=' | grep -v 'mtu 65536' | cut -d: -f1 | grep -w ${NETNAME})" ]; then
    echo
    echo "network interface name : ${NETNAME}"
    echo
    echo ${NETCONFIGFILE}:
    cat ${NETCONFIGFILE} | grep -v '#'
    echo
    exit
  else
    ASKNAME="YES"
  fi
fi
done

