#!/bin/bash
#by Wiboon Warasittichai, last updated 28-11-62
#

sname=$(basename "$0")
configtype="$1"

#get current working directory
cwd="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

#backup file first run this script
if [ ! -f $cwd/backupfile/01-netcfg.yaml.orig ]; then
  echo 
  echo "Backup /etc/netplan/01-netcfg.yaml to $cwd/backupfile/01-netcfg.yaml.orig"
  sudo mkdir -p $cwd/backupfile
  sudo cp -p /etc/netplan/01-netcfg.yaml $cwd/backupfile/01-netcfg.yaml.orig
fi

echo
echo "== $sname step 1/3 =="
sudo bash $cwd/setnetname.sh $configtype

while true; do
  echo "== $sname step 2/3 =="
  echo
  echo -n "Would you like to set network and server IP now "
  read -p "(y/n) " AKEY
  case ${AKEY} in
    [Yy]*) ANS="YES" ; break ;;
    [Nn]*) ANS="NO" ; break ;;
    *) echo "Please answer y or n." ;;
  esac
done
if [ "${ANS}" = "YES" ]; then
  sudo bash $cwd/setserverip.sh $configtype
else
  echo
fi

while true; do
  echo "== $sname step 3/3 =="
  echo
  echo -n "Would you like to set hostname now "
  read -p "(y/n) " AKEY
  case ${AKEY} in
    [Yy]*) ANS="YES" ; break ;;
    [Nn]*) ANS="NO" ; break ;;
    *) echo "Please answer y or n." ;;
  esac
done
if [ "${ANS}" = "YES" ]; then
  sudo bash $cwd/sethostname.sh $configtype
else
  echo
fi
#End.
